//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Mainly designed and written by Andr Slabber. No Rights Reserved...  Parts by others...
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  File:         ExportDlg.h
//  Module:       Diary
//  Author:       Andr Slabber
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Description:  Declaration of Class ExportDlg.
//
//////////////////////////////////////////////////////////////////////////////////////////////
#ifndef EXPORTDLG_H_INCLUDED
#define EXPORTDLG_H_INCLUDED

#include "afxdtctl.h"
#include "resource.h"
#include "sdate.h"

class SDiaryDlg;

enum OutputType
{
	enSimpleTextNoImages, 
	enSimpleHTMLNoImages,
	enSimpleHTMLInlineImages, 
	enSimpleHTMLLinkedImages, 
	enFramedHTML
};

// SExportDlg dialog

//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Class SExportDlg
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Description:  SExportDlg handles the interface that controls the export functionality. 
//                It is still under construction, because the export functionality is not to
//                appear until somewhere around version 5.05.
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Date		Name                  Comments
//	20080921	Andr Slabber         Created
//
//////////////////////////////////////////////////////////////////////////////////////////////
class SExportDlg : public CDialog
{
	DECLARE_DYNAMIC(SExportDlg)

public:
	SExportDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~SExportDlg();

// Dialog Data
	enum { IDD = IDD_EXPORT_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	BOOL SExportDlg::OnInitDialog(void);
    virtual void UpdateRadioButtons(void);
    virtual void SExportDlg::SavePosition(void);

	void PrintEntries(int NumDays);

	afx_msg void OnMcnSelchangeUptoCalendar(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnMcnSelchangeFromCalendar(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnGetdaystateMonthcalendar(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBnClickedOk();
	afx_msg void OnEnChangeMainFileSpec();
	afx_msg void OnBnClickedBrowse();
	afx_msg void OnBnClickedSimpleTextNoImages();
	afx_msg void OnBnClickedSimpleHTMLNoImages();
	afx_msg void OnBnClickedSimpleHTMLImagesInline();
	afx_msg void OnBnClickedSimpleHTMLImagesLinked();
	afx_msg void OnBnClickedFramedHTML();

protected:
	SDate mFromDate;
	SDate mUptoDate; 
	OutputType mOutputType; 
	CString mFullFileSpec;
	CString mExportPath;

private:
	CMonthCalCtrl m_FromCalendar;
	CMonthCalCtrl m_UptoCalendar;

   // stuff to correctly reposition if offscreen
   bool mWindowCentered;
   int  mTop;
   int  mLeft;

public:
	afx_msg void OnBnClickedExport();
};

#endif