//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Mainly designed and written by Andr Slabber. No Rights Reserved...  Parts by others...
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  File:         ImportDlg.h
//  Module:       Diary
//  Author:       Andr Slabber
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Description:  Declaration of Class ImportDlg.
//
//////////////////////////////////////////////////////////////////////////////////////////////
#ifndef IMPORTDLG_H_INCLUDED
#define IMPORTDLG_H_INCLUDED

#include "afxcmn.h"

class SDiaryDlg;  // no need to include the header, just declare the class.

//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Class SImportDlg
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Description:  This header file declares the SImportDlg class, that handles all functionality
//                of the Smart Import Dialog as found in the Diary application.
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Date		Name                  Comments
//	20080921	Andr Slabber         Created
//
//////////////////////////////////////////////////////////////////////////////////////////////
class SImportDlg : public CDialog
{
   DECLARE_DYNAMIC(SImportDlg)

   char *mCryptKey;
   bool mBefore;
   bool mAfter;
   bool mMerge;
   CRichEditCtrl m_Preview;
   CString mFullFileSpec;
   bool mBulkImport;

public:
   SImportDlg(CWnd* pParent = NULL);   // standard constructor
   virtual ~SImportDlg();

   virtual BOOL OnInitDialog();
   void SetCryptKey(char *pKey);
   char *GetCryptKey()                      { return mCryptKey;      };
   void SavePosition(void);

   enum { IDD = IDD_IMPORT_DIALOG };

protected:
   virtual void OnCancel();
   virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

   DECLARE_MESSAGE_MAP()

public:
   afx_msg void OnBnClickedBrowseFilename();
   afx_msg void OnBnClickedRadio2();
   afx_msg void OnBnClickedRadio3();
   afx_msg void OnBnClickedRadio4();
   afx_msg void OnEnKillfocusEncryptionKey();
   afx_msg void OnEnKillfocusImportFilename();
   virtual void UpdateRadioButtons(void);
   void SetPreviewForSingleFile(void);
   void SetFileListForMultipleFiles(void);
   afx_msg void OnBnClickedGo();

private:
   // stuff to correctly reposition if offscreen
   bool mWindowCentered;
   int  mTop;
   int  mLeft;

};

#endif