//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Mainly designed and written by Andr Slabber. No Rights Reserved...  Parts by others...
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  File:         Setting.cpp
//  Module:       Diary
//  Author:       Andr Slabber
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Description:  Implementation of Class Setting.
//
//////////////////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "setting.h"
#include "toolkit.h"

SSetting::SSetting(void)
{
   mName = "";
   mValue = "";
}

SSetting::SSetting(char *pName, char *pValue)
{
   mName = pName;
   mValue = pValue;
}

SSetting::~SSetting(void)
{
}

SSetting *SSetting::ReadSSetting(FILE *pFile)
{
   SSetting *lNewObject = NULL;
   char *lName = new char[MAX_STRING];
   char *lValue = new char[MAX_STRING];

   memset(lName, '\0', MAX_STRING);
   memset(lValue, '\0', MAX_STRING);

   char *theLetter = &lName[0];
   int lRead = fread(theLetter, 1, 1, pFile);
   while (lRead = 1 &&
	      theLetter < lName + MAX_STRING &&
		  *theLetter != ':')
   {
	   theLetter++;
	   lRead = fread(theLetter, 1, 1, pFile);
   }
   theLetter--;
   *theLetter = '\0';

   if (strlen(lName) > 0)
   {
	   theLetter = lValue;
	   fread(theLetter, 1, 1, pFile);
	   bool countSpaces = false;
	   while (*theLetter != '\n')
	   {
		   if (*theLetter != ' ')
		   {
			   countSpaces = true;
		   }
		   if (countSpaces || *theLetter != ' ')
		   {
		       theLetter++;
		   }
	       fread(theLetter, 1, 1, pFile);
	   }
	   *theLetter = '\0';
       lNewObject = new SSetting(lName, lValue);
   }

   delete [] lName;
   delete [] lValue;
    return lNewObject;
}

void SSetting::Dump(void)
{
   TK_LOG2("SSetting: %s = %s", 
          this->mName.GetBuffer(), 
         this->mValue.GetBuffer());
}

void SSetting::WriteSSetting(FILE *pFile)
{
   fprintf(pFile, "%s : %s", this->mName.GetBuffer(), this->mValue.GetBuffer());
   fprintf(pFile, "\n");
}