//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Mainly designed and written by Andr Slabber. No Rights Reserved...  Parts by others...
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  File:         SettingsFile.h
//  Module:       Diary
//  Author:       Andr Slabber
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Description:  Declaration of Class SettingsFile.
//
//////////////////////////////////////////////////////////////////////////////////////////////
#ifndef SETTINGSFILE_H_INCLUDED
#define SETTINGSFILE_H_INCLUDED

#include "diary.h"

#include "stdafx.h"
#include "setting.h"

#include <afxtempl.h>

// These strings avoid spelling errors in the settings names...
#define SET_FONT_SIZE      "FontSize"
#define SET_TOP            "PositionTop"
#define SET_LEFT           "PositionLeft"
#define SET_WIDTH          "PositionWidth"
#define SET_HEIGHT         "PositionHeight"
#define SET_SEARCH_TOP     "PositionSearchTop"
#define SET_SEARCH_LEFT    "PositionSearchLeft"
#define SET_SEARCH_WIDTH   "PositionSearchWidth"
#define SET_SEARCH_HEIGHT  "PositionSearchHeight"
#define SET_IMAGE_TOP      "PositionImageTop"
#define SET_IMAGE_LEFT     "PositionImageLeft"
#define SET_IMAGE_WIDTH    "PositionImageWidth"
#define SET_IMAGE_HEIGHT   "PositionImageHeight"
#define SET_IMPORT_TOP     "PositionImportTop"
#define SET_IMPORT_LEFT    "PositionImportLeft"
#define SET_EXPORT_TOP     "PositionExportTop"
#define SET_EXPORT_LEFT    "PositionExportLeft"
#define SET_FILES_TOP      "PositionFilesTop"
#define SET_FILES_LEFT     "PositionFilesLeft"
#define SET_LABEL_TOP      "PositionLabelTop"
#define SET_LABEL_LEFT     "PositionLabelLeft"
#define SET_LABEL_WIDTH    "PositionLabelWidth"
#define SET_LABEL_HEIGHT   "PositionLabelHeight"
#define SET_NUMDAYS        "NumberOfDays2Print"
#define SET_IMAGE_QUALITY  "ImageResizingQuality"
#define SET_UPGRADE_ANSWER "AlwaysUpgradeAnswer"
#define SET_TODOLIST_NAME  "ShowingTodolistName"


//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Class SSettingsFile
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Description:  SSettingsFile stores a set of SSetting objects in memory. These are typically
//                written to a specified disk file, for future reference. 
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Date		Name                  Comments
//	20080921	Andr Slabber         Created
//
//////////////////////////////////////////////////////////////////////////////////////////////
class SSettingsFile
{
protected:
   CList<SSetting *, SSetting *> mSettings;
   CString mFileName;
   boolean mSynchronized; 

public:
   SSettingsFile(void);
   virtual ~SSettingsFile(void);

   void SetFileName(char *pFileName);
   void ReadFile(void);
   void WriteFile(void);
   void Dump(void);
   void AddSetting(SSetting *&pNewSSetting);
   SSetting *GetSetting(char *pName);
};

#endif
