#include "stdafx.h"
#include "toolkit.h"

Exception::Exception(char *pFile, int pLine, RetCode pCode, char *pText)
{
   this->mFile = pFile;
   this->mLine = pLine;
   this->mCode = pCode;
   this->mText = pText;
}

Exception::~Exception(void)
{
}

void Exception::Log(void)
{
   if (this->getText() == NULL)
   {
      this->mText = RC2Txt(this->getCode());
   }
 
   Logger::Log(MT_FATAL, 
               this->getFile(),
               this->getLine(),
               this->getCode(), 
               "EXCEPTION: %s", 
               this->getText());
}

#ifdef TOOLKIT_SELFTEST
RetCode Exception::selfTest(void)
{
   RetCode lReturn = RC_OK;

   // Note the start of the selfTest in the logfile
   Logger::doubleLine();
   Logger::Log(MT_INFO, _FILE_, __LINE__, RC_OK, "Starting selfTest for Exception class");

   Exception lExc("testfile1.cpp", 123, RC_OK, "Exception on the stack");
   Logger::Log(MT_INFO, _FILE_, __LINE__, RC_OK, "File: %s", lExc.getFile());
   Logger::Log(MT_INFO, _FILE_, __LINE__, RC_OK, "Line: %d", lExc.getLine());
   Logger::Log(MT_INFO, _FILE_, __LINE__, RC_OK, "Code: %04X", lExc.getCode());
   Logger::Log(MT_INFO, _FILE_, __LINE__, RC_OK, "Text: %s", lExc.getText());

   Exception *lExc2 = new Exception("testfile2.cpp", 456, RC_FILE_ALREADY_OPEN, "Exception on the heap");
   Logger::Log(MT_INFO, _FILE_, __LINE__, RC_OK, "File: %s", lExc2->getFile());
   Logger::Log(MT_INFO, _FILE_, __LINE__, RC_OK, "Line: %d", lExc2->getLine());
   Logger::Log(MT_INFO, _FILE_, __LINE__, RC_OK, "Code: %04X", lExc2->getCode());
   Logger::Log(MT_INFO, _FILE_, __LINE__, RC_OK, "Text: %s", lExc2->getText());
   delete lExc2;

   // Note the end of the selfTest in the logfile
   Logger::Log(MT_INFO, _FILE_, __LINE__, RC_OK, "End of selfTest for Exception class"); 
   Logger::doubleLine();

   return lReturn;
}
#endif
