#ifndef EXCEPTION_H_INCLUDED
#define EXCEPTION_H_INCLUDED

#include <stdio.h>

#include "types.h"
#include "settings.h"

class Exception
{
private:
   char    *mFile;
   int      mLine;
   RetCode  mCode;
   char    *mText;

public:
   Exception(char *pfile, int pLine, RetCode pCode, char *pMsg = NULL);
   ~Exception(void);

   char    *getFile(void)       { return this->mFile; };
   int      getLine(void)       { return this->mLine; };
   RetCode  getCode(void)       { return this->mCode; };
   char    *getText(void)       { return this->mText; };

   void     Log(void);

#ifdef TOOLKIT_SELFTEST
   static RetCode selfTest(void);
#endif
};

#endif