#ifndef DATE_H_INCLUDED
#define DATE_H_INCLUDED

#define MAX_DAYS_TO_SCAN  (1825)

#define ENGLISH

#ifdef DUTCH

#define STR_NO_DAY     "Ongeldige dag"
#define STR_NO_MONTH   "Ongeldige maand"

#define STR_MONDAY     "Maandag"
#define STR_TUESDAY    "Dinsdag"
#define STR_WEDNESDAY  "Woensdag"
#define STR_THURSDAY   "Donderdag"
#define STR_FRIDAY     "Vrijdag"
#define STR_SATURDAY   "Zaterdag"
#define STR_SUNDAY     "Zondag"

#define STR_MON        " Ma"
#define STR_TUE        " Di"
#define STR_WED        " Wo"
#define STR_THU        " Do"
#define STR_FRI        " Vr"
#define STR_SAT        " Za"
#define STR_SUN        " Zo"
																 
#define STR_JANUARY    "Januari"
#define STR_FEBRUARY   "Februari"
#define STR_MARCH      "Maart"
#define STR_APRIL      "April"
#define STR_MAY        "Mei"
#define STR_JUNE       "Juni"
#define STR_JULY       "Juli"
#define STR_AUGUST     "Augustus"
#define STR_SEPTEMBER  "September"
#define STR_OCTOBER    "Oktober"
#define STR_NOVEMBER   "November"
#define STR_DECEMBER   "December"

#define STR_JAN        "Jan"
#define STR_FEB        "Feb"
#define STR_MAR        "Maa"
#define STR_APR        "Apr"
#define STR_MAY        "Mei"
#define STR_JUN        "Jun"
#define STR_JUL        "Jul"
#define STR_AUG        "Aug"
#define STR_SEP        "Sep"
#define STR_OCT        "Okt"
#define STR_NOV        "Nov"
#define STR_DEC        "Dec"

#endif

#ifdef ENGLISH

#define STR_NO_DAY     "Invalid day"
#define STR_NO_MONTH   "Invalid month"

#define STR_MONDAY     "Monday"
#define STR_TUESDAY    "Tuesday"
#define STR_WEDNESDAY  "Wednesday"
#define STR_THURSDAY   "Thursday"
#define STR_FRIDAY     "Friday"
#define STR_SATURDAY   "Saturday"
#define STR_SUNDAY     "Sunday"

#define STR_MON        "Mon"
#define STR_TUE        "Tue"
#define STR_WED        "Wed"
#define STR_THU        "Thu"
#define STR_FRI        "Fri"
#define STR_SAT        "Sat"
#define STR_SUN        "Sun"
																 
#define STR_JANUARY    "January"
#define STR_FEBRUARY   "February"
#define STR_MARCH      "March"
#define STR_APRIL      "April"
#define STR_MAY        "May"
#define STR_JUNE       "June"
#define STR_JULY       "July"
#define STR_AUGUST     "August"
#define STR_SEPTEMBER  "September"
#define STR_OCTOBER    "October"
#define STR_NOVEMBER   "November"
#define STR_DECEMBER   "December"

#define STR_JAN        "Jan"
#define STR_FEB        "Feb"
#define STR_MAR        "Mar"
#define STR_APR        "Apr"
#define STR_MAY        "May"
#define STR_JUN        "Jun"
#define STR_JUL        "Jul"
#define STR_AUG        "Aug"
#define STR_SEP        "Sep"
#define STR_OCT        "Oct"
#define STR_NOV        "Nov"
#define STR_DEC        "Dec"

#endif

#define INVALID_MONTH  (0)
#define	JANUARY        (1)
#define	FEBRUARY       (2)
#define	MARCH          (3)
#define	APRIL          (4)
#define	MAY            (5)
#define	JUNE           (6)
#define	JULY           (7)
#define	AUGUST         (8)
#define	SEPTEMBER      (9)
#define	OCTOBER       (10)
#define	NOVEMBER      (11)
#define	DECEMBER      (12)

typedef enum
{
    INVALID_DAY = 0, 
	MONDAY,
	TUESDAY,
	WEDNESDAY,
	THURSDAY,
	FRIDAY,
	SATURDAY,
	SUNDAY

}	enWeekday;

class SDate
{
private:
   int   mYear;
   int   mMonth;
   int   mDay;

public:
            SDate(void);
            SDate(long pDecimalDate);
            SDate(int pYear, int pMonth, int pDays);
   virtual ~SDate(void);

   int  getYear(void)          { return this->mYear; };
   int  getMonth(void)         { return this->mMonth; };
   int  getDays(void)          { return this->mDay; };

   int  daysFrom(SDate theOtherDate);

   SDate &operator = (SYSTEMTIME pOtherDate);
   SDate &operator = (SDate &pOtherDate);
   bool operator != (SDate &pOtherDate);
   bool operator >= (SDate &pOtherDate);
   bool operator <= (SDate &pOtherDate);
   bool operator > (SDate &pOtherDate);
   bool operator < (SDate &pOtherDate);

   long asDecimal(void);
   static long   asDecimal(int pYear, int pMonth, int pDay);
   void Set(int pYear, int pMonth, int pDays, bool pCanCorrect = true);
   void Set(long pDecimalDate, bool pCanCorrect = true);
   void Set(char *pDecimalString, bool pCanCorrect = true);
   void Add(int pYears, int pMonths, int pDays);
   void Subtract(int pYears, int pMonths, int pDays);
   char *dayAsLongString(void);
   static void FindFirstValidDate(int *pYear, int *pMonth, int *pDays);
   static char *getDateSuffix(int pDate);

   static enWeekday  calculateWeekDay (int pYear, int pMonth, int pDay);
   static void       DecimalDateAsParts(long     pDate, 
	                                     int   *pYear, 
				                            int *pMonth, 
                                        int   *pDay);

   static bool       isValidDate(int pYear, int pMonth, int pDay);
   static bool       isLeapYear(int pYear);
   static int        maxDaysInMonth(int pYear, int pMonth);

   static char *     dayAsLongString(enWeekday pDay);
   static char *     dayAsShortString(enWeekday pDay);
   static char *     monthAsLongString(int pMonth);
   static char *     monthAsShortString(int pMonth);

protected:
   static int		 findDoomsDate(int pYear, int pMonth);
   static enWeekday	 findDoomsDay(int pYear, int pMonth, int pDay);
};

#endif
