#ifndef SETTINGS_H_INCLUDED
#define SETTINGS_H_INCLUDED

// This file contains the switch settings for the C++
// Programmer's Toolkit, that enable or disable the 
// various parts of it. First of all, you select a 
// set of switches by either defining or undefining 
// TOOLKIT_DEBUG. Based on this, either the first or
// the second set of switches will be set. This allows
// for fast switching between two complete settings. 
// SSetting the defines in the two sets allows you to 
// enable or disable separate parts of the toolkit. 
// The rest of this file is used to switch on dependent 
// parts of the toolkit based on the settings you set. 

#undef  TOOLKIT_DEBUG
#ifdef  _DEBUG
#define TOOLKIT_DEBUG
#endif

// First, set all settings for TOOLKIT_DEBUG state

#ifdef  TOOLKIT_DEBUG

#define TOOLKIT_LOGNAME   "diary_debug.log"
#define TOOLKIT_LOGFILE
#define TOOLKIT_LOGGING
#define TOOLKIT_PARMS
#define TOOLKIT_TRACING
#define TOOLKIT_TIMING
#define TOOLKIT_THROWS
#define TOOLKIT_CATCHES
#undef  TOOLKIT_SELFTEST
#undef  TOOLKIT_SYSTEMTEST

#else

// Next, set all settings for TOOLKIT_RELEASE state

#define TOOLKIT_LOGNAME   "toolkit_release.log"
#undef  TOOLKIT_LOGFILE
#undef  TOOLKIT_LOGGING
#undef  TOOLKIT_PARMS
#undef  TOOLKIT_TRACING
#undef  TOOLKIT_TIMING
#undef  TOOLKIT_THROWS
#undef  TOOLKIT_CATCHES
#undef  TOOLKIT_SELFTEST
#undef  TOOLKIT_SYSTEMTEST

#endif  // TOOLKIT_RELEASE

// Behind this line the dependent choices are set. You 
// do not normally need to change anything here unless 
// there's a bug. 

#ifdef  TOOLKIT_LOGGING
#define TOOLKIT_LOGFILE
#endif

#ifdef  TOOLKIT_TRACING
#define TOOLKIT_LOGFILE
#endif

#ifdef  TOOLKIT_TIMING
#define TOOLKIT_LOGFILE
#endif

#ifdef  TOOLKIT_SYSTEMTEST
#define TOOLKIT_SELFTEST
#endif

#endif  // SETTINGS_H_INCLUDED