#include "stdafx.h"
#include "tools.h"
#include <afxinet.h>				// Needed for CHttpFile & CInternetSession

bool STools::isDigit(char pChar)
{
   switch(pChar)
   {
   case '0':
   case '1':
   case '2':
   case '3':
   case '4':
   case '5':
   case '6':
   case '7':
   case '8':
   case '9':
      return true;

   default:
      return false;
   }
   return false;
}

bool STools::isWhiteSpace(char pChar)
{
	switch(pChar)
	{
	case ' ':
	case '\t':
	case '\r':
	case '\n':
	case '(':  // special characters are also considered whitespace. 
	case ')':
	//case '.':  // not this, breaks URLs
	case ',':
		return true;

	default:
		return false;
	}
	return false;
}

void STools::EatWhite(char *&pChars)
{
   while (*pChars == '\r' || *pChars == '\n' || *pChars == ' ')
   {   
      pChars++;
      if (*pChars == '\0')
      {
         break;
      }
   }  
}

bool STools::ReadWebFile(CString &theURL, 
	                     CString &theFileContents)
{
	CInternetSession iSession;

	iSession.SetOption( INTERNET_OPTION_DATA_RECEIVE_TIMEOUT, 0 );

	// 	INTERNET_PROXY_INFO proxyinfo;
	// 	proxyinfo.dwAccessType = INTERNET_OPEN_TYPE_PROXY;
	// 	proxyinfo.lpszProxy = temp;
	// 	proxyinfo.lpszProxyBypass = NULL;
	// 	iSession.SetOption( INTERNET_OPTION_PROXY, (LPVOID)&proxyinfo, sizeof(INTERNET_PROXY_INFO ) );

	CHttpFile* pFile = NULL;

	try
	{
		DWORD dwFlags = INTERNET_FLAG_TRANSFER_ASCII | INTERNET_FLAG_DONT_CACHE;

		pFile =( CHttpFile* )iSession.OpenURL( theURL, 1, dwFlags );
	}
	catch (CInternetException* e)
	{
		e->Delete();

		delete pFile;
		pFile = NULL;

		return false;
	}

	BYTE buffer[ 4096 + 1 ];
	DWORD dwCount = 0;
	CString strBuffer;

	if (pFile)
	{
		try {
			UINT nRead = 0;
			dwCount = 0;
			do
			{
				::memset( buffer, 0, sizeof( buffer ) );
				nRead = pFile->Read(buffer, 1024);
				if (nRead > 0)
				{
					buffer[nRead] = 0;

					LPTSTR ptr = theFileContents.GetBufferSetLength(dwCount + nRead);
					memcpy(ptr+dwCount, buffer, nRead);

					dwCount += nRead;
					theFileContents.ReleaseBuffer(dwCount);
				}
			}
			while (nRead > 0);

			pFile->Close();
			delete pFile;
		}
		catch (CFileException *e)
		{
			e->Delete();

			pFile->Close();
			delete pFile;

			return false;
		}
	}

	// Remove double new lines
	theFileContents.Replace( "\r", "" );


	//MessageBox(a_strBuffer, "INFO", MB_OK);

	return true;
}

bool STools::ReadBinaryWebFile(CString &theURL, 
							   CString &theFileSpec,
							   const char *theMessage, 
							   CStatic *theStatic)
{
	CInternetSession iSession;

	iSession.SetOption( INTERNET_OPTION_DATA_RECEIVE_TIMEOUT, 0 );

	// 	INTERNET_PROXY_INFO proxyinfo;
	// 	proxyinfo.dwAccessType = INTERNET_OPEN_TYPE_PROXY;
	// 	proxyinfo.lpszProxy = temp;
	// 	proxyinfo.lpszProxyBypass = NULL;
	// 	iSession.SetOption( INTERNET_OPTION_PROXY, (LPVOID)&proxyinfo, sizeof(INTERNET_PROXY_INFO ) );

	CHttpFile* pFile = NULL;

	try
	{
		DWORD dwFlags = INTERNET_FLAG_TRANSFER_BINARY | INTERNET_FLAG_DONT_CACHE;

		pFile =( CHttpFile* )iSession.OpenURL( theURL, 1, dwFlags );
	}
	catch (CInternetException* e)
	{
		e->Delete();
		delete pFile;
		pFile = NULL;
		return false;
	}

	BYTE buffer[ 4096 + 1 ];
	DWORD dwCount = 0;
	CString strBuffer;

	FILE *theOutFile = fopen(theFileSpec, "wb");
	if (theOutFile == 0)
	{
		delete pFile;
		pFile = NULL;
		return false;
	}

	if (pFile)
	{
		try {
			UINT nRead = 0;
			dwCount = 0;
			do
			{
				if (theStatic != 0 && theMessage != 0)
				{
					int theByteSize = dwCount / 1024;
					char theChunkchar = 'K';
					if (theByteSize > 1024)
					{
						theByteSize=  theByteSize / 1024;
						theChunkchar = 'M';
					}
					CString theFormatString = theMessage;
					CString theMsg;
					theMsg.Format(theFormatString, theByteSize, theChunkchar);
					theStatic->SetWindowTextA(theMsg);
				}
				::memset( buffer, 0, sizeof( buffer ) );
				nRead = pFile->Read(buffer, 1024);
				if (nRead > 0)
				{
					buffer[nRead] = 0;

					if (fwrite(buffer, 1, nRead, theOutFile) != nRead)
					{
						pFile->Close();
						delete pFile;
						fclose(theOutFile);
						return false;
					}

					dwCount += nRead;
				}
			}
			while (nRead > 0);

			pFile->Close();
			delete pFile;

			fclose(theOutFile);
		}
		catch (CFileException *e)
		{
			e->Delete();

			pFile->Close();
			delete pFile;
			fclose(theOutFile);
			return false;
		}
	}

	return true;
}